Public Class VierGewinntFeld
    Inherits System.Windows.Forms.Control

#Region " Vom Component Designer generierter Code "

    Public Sub New()
        MyBase.New()

        'Dieser Aufruf ist fr den Komponenten-Designer erforderlich.
        InitializeComponent()

        'Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu
        setstyle(ControlStyles.AllPaintingInWmPaint, True)
        setstyle(ControlStyles.DoubleBuffer, True)
        setstyle(ControlStyles.UserPaint, True)
        Me.LeereSpielfeldIntern()
    End Sub

    'Das Steuerelement berschreibt den Lschvorgang zum Bereinigen der Komponentenliste.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Fr den Steuerelement-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    ' HINWEIS: Die folgende Prozedur ist fr den Komponenten-Designer erforderlich.
    ' Sie kann mit dem Komponenten-Designer bearbeitet werden. Verwenden Sie nicht den
    ' Code-Editor zur Bearbeitung.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

#End Region

#Region "ffentliche Events"

    Public Event MenschHatGewonnen()

    Public Event ComputerHatGewonnen()

    Public Event MenschHatGezogen()

    Public Event ComputerHatGezogen()

    Public Event Unentschieden()

    Public Event BerechnungLaeuft(ByVal Prozent As Long)

#End Region

#Region "ffentliche Konstanten und Typen"

    Public Const Spalten As Integer = 7, _
                 Zeilen As Integer = 6, _
                 MaxSpalte As Integer = Spalten - 1, _
                 MaxZeile As Integer = Zeilen - 1, _
                 KeineMarkierungsSpalte As Integer = -1, _
                 BlinkIntervall As Integer = 100, _
                 BlinkAnzahl As Integer = 5

    Public Enum ZellenStatus
        LeereZelle
        ComputerZelle
        SpielerZelle
        SpielerMarkierungsZelle
    End Enum

    Public Enum TerminalOptimierungen
        aus
        mittel
        stark
    End Enum

#End Region

#Region "Private Variable"

    Private BlinkZeile As Integer, _
            BlinkSpalte As Integer, _
            BlinkZaehler As Integer = 0

    Private WithEvents BlinkTimer As New Timer

    Private Gewinnreihen As Collection ' Bestehend aus GewinnReihe-Objekten.

    Private Spielfeld(MaxSpalte, MaxZeile) As ZellenStatus
    ' Spalte 0 ist links, Zeile 0 ist unten

    Private _UntersteFreieZeile(MaxSpalte) As Integer
    ' Der Index der untersten freien Zeile jeder Spalte.

    Private _FreieFelder As Integer
    ' Die insgesamt noch freien Felder.

    Private MarkierungsSpalte As Integer
    ' KeineMarkierungsSpalte: kein Markierung; 0 bis MaxSpalte: Rechteck

    Private _SpielIstFertig As Boolean
    ' Ist das Spiel beendet?

    Private FeldX0, FeldY0, FeldDXY As Integer
    ' Linke obere Ecke des Spielfeldes sowie Breite und Hhe eines Feldes.

    Private Rand As Integer
    ' Der Rand innerhalb einer Zelle um den Kreis herum.

    Private _Siegrahmen As Boolean = True
    ' Soll ein Rand um die Siegzellen gezogen werden?

    Private _ZugAnzahl As Integer = 1

    Private _TerminalOptimierung As TerminalOptimierungen = TerminalOptimierung.aus

#End Region

#Region "Private Klassen"

    Private Class GewinnReihe

        Private x1, y1, x2, y2 As Integer

        Public Sub New(ByVal xAnfang As Integer, _
                       ByVal yAnfang As Integer, _
                       ByVal xEnde As Integer, _
                       ByVal yEnde As Integer)
            If xAnfang < xEnde Then
                x1 = xAnfang
                y1 = yAnfang
                x2 = xEnde
                y2 = yEnde
            Else
                x1 = xEnde
                y1 = yEnde
                x2 = xAnfang
                y2 = yAnfang
            End If
        End Sub

        Private Sub FillOrDraw(ByVal g As Graphics, _
                               ByVal FeldDXY As Integer, _
                               ByVal FeldX0 As Integer, _
                               ByVal FeldY0 As Integer, _
                               ByVal Rand As Integer, _
                               ByVal Fill As Boolean)

            Dim Path As New Drawing2D.GraphicsPath, _
                delta As Integer, _
                P0, P1, P2, P3 As Point, _
                Winkel As Integer

            delta = FeldDXY \ 2 + Rand \ 2
            If delta > 0 Then
                If x1 <> x2 And y1 <> y2 Then
                    delta = CInt(CDbl(delta) / Math.Sqrt(2))
                End If
                P0 = New Point(FeldX0 + FeldDXY * x1 + FeldDXY \ 2, _
                               FeldY0 + FeldDXY * (MaxZeile - y1) + FeldDXY \ 2)
                P2 = New Point(P0.X, P0.Y)
                P1 = New Point(FeldX0 + FeldDXY * x2 + FeldDXY \ 2, _
                               FeldY0 + FeldDXY * (MaxZeile - y2) + FeldDXY \ 2)
                P3 = New Point(P1.X, P1.Y)
                If x1 = x2 Then
                    P0.X += delta
                    P1.X += delta
                    P2.X -= delta
                    P3.X -= delta
                    Winkel = 0
                ElseIf y1 = y2 Then
                    P0.Y += delta
                    P1.Y += delta
                    P2.Y -= delta
                    P3.Y -= delta
                    Winkel = 90
                ElseIf y1 < y2 Then
                    P0.X += delta
                    P0.Y += delta
                    P1.X += delta
                    P1.Y += delta
                    P2.X -= delta
                    P2.Y -= delta
                    P3.X -= delta
                    P3.Y -= delta
                    Winkel = 45
                Else
                    P0.X -= delta
                    P0.Y += delta
                    P1.X -= delta
                    P1.Y += delta
                    P2.X += delta
                    P2.Y -= delta
                    P3.X += delta
                    P3.Y -= delta
                    Winkel = 45 + 90
                End If
                Path.AddArc(FeldX0 + x2 * FeldDXY + Rand, _
                    FeldY0 + (MaxZeile - y2) * FeldDXY + Rand, _
                    FeldDXY - 2 * Rand, FeldDXY - 2 * Rand, Winkel, -180)
                Path.AddArc(FeldX0 + x1 * FeldDXY + Rand, _
                    FeldY0 + (MaxZeile - y1) * FeldDXY + Rand, _
                    FeldDXY - 2 * Rand, FeldDXY - 2 * Rand, Winkel + 180, -180)
                Path.CloseAllFigures()
                If Fill Then
                    g.FillPath(New SolidBrush(Color.FromArgb(128, 255, 255, 255)), _
                        Path)
                ElseIf Rand > 0 Then
                    g.DrawPath(New Pen(Color.DarkGreen, Rand), Path)
                End If
            End If
        End Sub

        Public Sub Draw(ByVal g As Graphics, _
                        ByVal FeldDXY As Integer, _
                        ByVal FeldX0 As Integer, _
                        ByVal FeldY0 As Integer, _
                        ByVal Rand As Integer)
            FillOrDraw(g, FeldDXY, FeldX0, FeldY0, Rand, False)
        End Sub

        Public Sub Fill(ByVal g As Graphics, _
                        ByVal FeldDXY As Integer, _
                        ByVal FeldX0 As Integer, _
                        ByVal FeldY0 As Integer, _
                        ByVal Rand As Integer)
            FillOrDraw(g, FeldDXY, FeldX0, FeldY0, Rand, True)
        End Sub
    End Class

#End Region

#Region "Private Hilfsroutinen"

    Private Sub BerechneSpielfeldMasse()
        If Me.ClientSize.Width \ Spalten < Me.ClientSize.Height \ Zeilen Then
            FeldDXY = Me.ClientSize.Width \ Spalten
            FeldX0 = 0
            FeldY0 = (Me.ClientSize.Height - Zeilen * FeldDXY) \ 2
        Else
            FeldDXY = Me.ClientSize.Height \ Zeilen
            FeldX0 = (Me.ClientSize.Width - Spalten * FeldDXY) \ 2
            FeldY0 = 0
        End If
        Rand = FeldDXY \ 20
        If Rand = 0 And FeldDXY > 2 Then
            Rand = 1
        End If
    End Sub

    Private Sub LeereSpielfeldIntern()

        Dim Spalte, Zeile As Integer

        For Spalte = 0 To MaxSpalte
            For Zeile = 0 To MaxZeile
                Spielfeld(Spalte, Zeile) = ZellenStatus.LeereZelle
            Next
            _UntersteFreieZeile(Spalte) = 0
        Next
        _FreieFelder = Zeilen * Spalten
        MarkierungsSpalte = KeineMarkierungsSpalte
        _SpielIstFertig = False
        Gewinnreihen = New Collection
        _ZugAnzahl = 1
    End Sub

    Private Sub StarteBlinken(ByVal Zeile As Integer, ByVal Spalte As Integer)
        BlinkZeile = Zeile
        BlinkSpalte = Spalte
        BlinkTimer = New Timer
        BlinkTimer.Interval = BlinkIntervall
        BlinkZaehler = BlinkAnzahl
        BlinkTimer.Enabled = True
    End Sub

    Private Sub SetzeComputerZug(ByVal Spalte As Integer)

        Dim Zeile As Integer

        Zeile = _UntersteFreieZeile(Spalte)
        SetzeFeld(Spalte, ZellenStatus.ComputerZelle, True)
        ' Hat der Computer gewonnen?
        If VierInEinerReihe(Spalte, Zeile) Then
            VierInEinerReiheIntern(Spalte, Zeile, True, False)
            _SpielIstFertig = True
            RaiseEvent ComputerHatGewonnen()
        Else
            StarteBlinken(Zeile, Spalte)
            If _FreieFelder = 0 Then
                _SpielIstFertig = True
                RaiseEvent Unentschieden()
            Else
                RaiseEvent ComputerHatGezogen()
            End If
        End If
    End Sub

    Private Sub InvalidateSpalteZeile(ByVal Spalte As Integer, _
                                      ByVal Zeile As Integer)
        Invalidate(New Rectangle(FeldX0 + Spalte * FeldDXY, _
            FeldY0 + (MaxZeile - Zeile) * FeldDXY, _
            FeldDXY, FeldDXY))
    End Sub

    Private Sub EntferneMarkierung()
        If MarkierungsSpalte >= 0 Then
            Spielfeld(MarkierungsSpalte, UntersteFreieZeile(MarkierungsSpalte)) = ZellenStatus.LeereZelle
            InvalidateSpalteZeile(MarkierungsSpalte, UntersteFreieZeile(MarkierungsSpalte))
            MarkierungsSpalte = KeineMarkierungsSpalte
        End If
    End Sub

    Private Function CursorIstInSpalte(ByVal MouseX As Integer, _
                                       ByRef Spalte As Integer) As Boolean
        If MouseX < FeldX0 Or MouseX >= FeldX0 + Spalten * FeldDXY Then
            Return False
        Else
            Spalte = (MouseX - FeldX0) \ FeldDXY
            Return True
        End If
    End Function

    Private Sub AddiereGleiche(ByVal Spalte As Integer, _
                               ByVal Zeile As Integer, _
                               ByVal dx As Integer, _
                               ByVal dy As Integer, _
                               ByVal Farbe As ZellenStatus, _
                               ByRef Anzahl As Integer)
        Anzahl = 0
        Do
            Spalte = Spalte + dx
            Zeile = Zeile + dy
            If Spalte >= 0 AndAlso Spalte <= MaxSpalte _
                AndAlso Zeile >= 0 AndAlso Zeile <= MaxZeile _
                AndAlso Spielfeld(Spalte, Zeile) = Farbe Then
                Anzahl = Anzahl + 1
            Else
                Exit Do
            End If
        Loop
    End Sub

    Private Sub PruefeReihe(ByVal AusgangsSpalte As Integer, _
                            ByVal AusgangsZeile As Integer, _
                            ByVal dx As Integer, _
                            ByVal dy As Integer, _
                            ByRef gewonnen As Boolean, _
                            ByVal Markieren As Boolean, _
                            ByVal Hell As Boolean)

        Dim Farbe As ZellenStatus, _
            Laenge1, Laenge2 As Integer

        Farbe = Spielfeld(AusgangsSpalte, AusgangsZeile)
        AddiereGleiche(AusgangsSpalte, AusgangsZeile, dx, dy, Farbe, Laenge1)
        AddiereGleiche(AusgangsSpalte, AusgangsZeile, -dx, -dy, Farbe, Laenge2)
        If Laenge1 + Laenge2 >= 3 Then
            ' Mindestens 3 plus die Ausgangszelle selbst sind mindestens 4, also:
            gewonnen = True
            If Markieren Then
                Gewinnreihen.Add(New GewinnReihe(AusgangsSpalte + dx * Laenge1, _
                    AusgangsZeile + dy * Laenge1, _
                    AusgangsSpalte - dx * Laenge2, _
                    AusgangsZeile - dy * Laenge2))
            End If
        End If
    End Sub

    Private Function VierInEinerReiheIntern(ByRef AusgangsSpalte As Integer, _
                                            ByRef AusgangsZeile As Integer, _
                                            ByVal Markieren As Boolean, _
                                            ByVal Hell As Boolean) As Boolean

        Dim gewonnen As Boolean

        gewonnen = False
        ' waagerecht
        PruefeReihe(AusgangsSpalte, AusgangsZeile, 0, 1, gewonnen, Markieren, Hell)
        ' senkrecht
        PruefeReihe(AusgangsSpalte, AusgangsZeile, 1, 0, gewonnen, Markieren, Hell)
        ' diagonal aufwrts
        PruefeReihe(AusgangsSpalte, AusgangsZeile, 1, 1, gewonnen, Markieren, Hell)
        ' diagonal abwrts
        PruefeReihe(AusgangsSpalte, AusgangsZeile, 1, -1, gewonnen, Markieren, Hell)
        If gewonnen And Markieren Then
            Invalidate()
        End If
        Return gewonnen
    End Function

    Private Sub BewerteSpalte(ByVal Spalte As Integer, _
                              ByRef Bewertung As Integer, _
                              ByVal Vorzeichen As Integer, _
                              ByVal TiefenFaktor As Integer, _
                              ByVal EigeneFarbe As VierGewinntFeld.ZellenStatus, _
                              ByVal GegnerFarbe As VierGewinntFeld.ZellenStatus)

        Dim GegnerSpalte As Integer

        If _UntersteFreieZeile(Spalte) <= VierGewinntFeld.MaxZeile Then
            SetzeFeld(Spalte, EigeneFarbe, False)
            If VierInEinerReihe(Spalte, _UntersteFreieZeile(Spalte) - 1) Then
                ' Sieg fr EigeneFarbe
                Bewertung = Bewertung + Vorzeichen * TiefenFaktor
            ElseIf TiefenFaktor > 1 Then
                For GegnerSpalte = 0 To VierGewinntFeld.MaxSpalte
                    BewerteSpalte(GegnerSpalte, Bewertung, _
                        -Vorzeichen, TiefenFaktor \ (VierGewinntFeld.Spalten + 1), _
                        GegnerFarbe, EigeneFarbe)
                Next
            End If
            EntferneFeld(Spalte)
        End If
    End Sub

#End Region

#Region "ffentliche Eigenschaften und Methoden"

    Public Property Siegrahmen() As Boolean
        Get
            Return _Siegrahmen
        End Get
        Set(ByVal Value As Boolean)
            If _Siegrahmen <> Value Then
                _Siegrahmen = Value
                If Gewinnreihen.Count > 0 Then
                    Invalidate()
                End If
            End If
        End Set
    End Property

    Public Property TerminalOptimierung() As TerminalOptimierungen
        Get
            Return _TerminalOptimierung
        End Get
        Set(ByVal Value As TerminalOptimierungen)
            If Value <> _TerminalOptimierung Then
                _TerminalOptimierung = Value
                Me.Invalidate()
            End If
        End Set
    End Property

    Public ReadOnly Property ZugAnzahl() As Integer
        Get
            Return _ZugAnzahl
        End Get
    End Property

    Public ReadOnly Property SpielIstFertig() As Boolean
        Get
            Return _SpielIstFertig
        End Get
    End Property

    Public ReadOnly Property FreieFelder() As Long
        Get
            Return _FreieFelder
        End Get
    End Property

    Public Sub LeereSpielfeld()
        LeereSpielfeldIntern()
        Invalidate()
    End Sub

    Public Function UntersteFreieZeile(ByVal Spalte As Integer) As Integer
        Return _UntersteFreieZeile(Spalte)
    End Function

    Public Sub SetzeFeld(ByVal Spalte As Integer, _
                         ByVal Farbe As ZellenStatus, _
                         ByVal Anzeigen As Boolean)
        Spielfeld(Spalte, UntersteFreieZeile(Spalte)) = Farbe
        If Anzeigen Then
            InvalidateSpalteZeile(Spalte, UntersteFreieZeile(Spalte))
        End If
        _UntersteFreieZeile(Spalte) = _UntersteFreieZeile(Spalte) + 1
        _FreieFelder = _FreieFelder - 1
    End Sub

    Public Sub EntferneFeld(ByRef Spalte As Integer)
        _UntersteFreieZeile(Spalte) = _UntersteFreieZeile(Spalte) - 1
        Spielfeld(Spalte, UntersteFreieZeile(Spalte)) = ZellenStatus.LeereZelle
        _FreieFelder = _FreieFelder + 1
    End Sub

    Public Function VierInEinerReihe(ByRef AusgangsSpalte As Integer, _
                                     ByRef AusgangsZeile As Integer) As Boolean
        Return VierInEinerReiheIntern(AusgangsSpalte, AusgangsZeile, False, False)
    End Function

    Public Sub ComputerZug(ByVal Rechentiefe As Long)

        ' * Zhle die Zge, die zum sofortigen Gewinn fhren.
        ' * Wie viele solche Gewinnzge gibt es?
        '   * mindestens einen:
        '     * Nimm einen schnen davon und gewinne!
        '   * keinen:
        '     * Fr alle mglichen Gegnerzge:
        '       * Zhle die Zge, die zur sofortigen Niederlage fhren wrden.
        '         * Zhle die Zge, die zum sofortigen Gewinn fhren.
        '         * Zhle die Zge, bei denen der Gegner im nchsten Schritt
        '           gewinnen knnte.

        Dim Spalte As Integer, _
            Bewertung As Integer, _
            HchsteBewertung As Integer, _
            Beste(VierGewinntFeld.Spalten) As Integer, _
            BesteSpalten As Integer, _
            BesteSpalte As Integer, _
            R As New Random

        'Dim s As String

        Me.Update()
        Me.Cursor = Cursors.WaitCursor
        BesteSpalten = -1
        HchsteBewertung = 0
        ' ProgressBar.Maximum = Spalten
        ' ProgressBar.Value = 0
        ' ProgressBar.Visible = True
        For Spalte = 0 To VierGewinntFeld.MaxSpalte
            ' ProgressBar.Value = Spalte
            RaiseEvent BerechnungLaeuft(CInt(Spalte / VierGewinntFeld.Spalten * 100))
            If _UntersteFreieZeile(Spalte) <= VierGewinntFeld.MaxZeile Then
                Bewertung = 0
                BewerteSpalte(Spalte, Bewertung, 1, _
                    CInt((VierGewinntFeld.Spalten + 1) ^ Rechentiefe), _
                    VierGewinntFeld.ZellenStatus.ComputerZelle, _
                    VierGewinntFeld.ZellenStatus.SpielerZelle)
                'If Spalte > 0 Then
                '    s = s & "   "
                'End If
                's = s & Bewertung.ToString
                If BesteSpalten < 0 Or Bewertung >= HchsteBewertung Then
                    ' Diese Spalte nehmen!
                    If BesteSpalten >= 0 And Bewertung > HchsteBewertung Then
                        BesteSpalten = 0
                    Else
                        BesteSpalten = BesteSpalten + 1
                    End If
                    Beste(BesteSpalten) = Spalte
                    HchsteBewertung = Bewertung
                End If
            End If
        Next
        ' ProgressBar.Visible = False
        BesteSpalte = Beste(R.Next(BesteSpalten))
        Me.Cursor = System.Windows.Forms.Cursors.Default
        SetzeComputerZug(BesteSpalte)
    End Sub

#End Region

#Region "Reaktion auf Windows-Forms- und Timer-Ereignisse"

    Private Sub VierGewinntFeld_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.MouseLeave
        EntferneMarkierung()
    End Sub

    Private Sub VierGewinnt_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove

        Dim ZielSpalte As Integer

        If (Not SpielIstFertig) AndAlso CursorIstInSpalte(e.X, ZielSpalte) Then
            If MarkierungsSpalte <> ZielSpalte Then
                EntferneMarkierung()
                If UntersteFreieZeile(ZielSpalte) <= MaxZeile Then
                    MarkierungsSpalte = ZielSpalte
                    Spielfeld(MarkierungsSpalte, UntersteFreieZeile(MarkierungsSpalte)) = ZellenStatus.SpielerMarkierungsZelle
                    InvalidateSpalteZeile(MarkierungsSpalte, UntersteFreieZeile(MarkierungsSpalte))
                    Me.Cursor = Cursors.Default
                Else
                    Me.Cursor = Cursors.No
                End If
            End If
        Else
            EntferneMarkierung()
        End If
    End Sub

    Private Sub VierGewinnt_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp

        Dim ZielSpalte, ZielZeile As Integer

        If (Not SpielIstFertig) AndAlso CursorIstInSpalte(e.X, ZielSpalte) Then
            EntferneMarkierung()
            If BlinkZaehler > 0 Then
                BlinkZaehler = 0
                BlinkTimer.Enabled = False
                InvalidateSpalteZeile(BlinkSpalte, BlinkZeile)
            End If
            ZielZeile = UntersteFreieZeile(ZielSpalte)
            If ZielZeile <= MaxZeile Then
                EntferneMarkierung()
                SetzeFeld(ZielSpalte, ZellenStatus.SpielerZelle, True)
                _ZugAnzahl += 1
                Me.Update()
                ' Hat der Spieler gewonnen?
                If VierInEinerReihe(ZielSpalte, ZielZeile) Then
                    VierInEinerReiheIntern(ZielSpalte, ZielZeile, True, True)
                    _SpielIstFertig = True
                    RaiseEvent MenschHatGewonnen()
                ElseIf _FreieFelder = 0 Then
                    _SpielIstFertig = True
                    RaiseEvent Unentschieden()
                Else
                    RaiseEvent MenschHatGezogen()
                End If
            End If
        End If
    End Sub

    Private Sub VierGewinntFeld_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        BerechneSpielfeldMasse()
        Invalidate()
    End Sub

    Private Sub VierGewinntFeld_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

        Dim Zeile, Spalte As Integer, _
            R As Rectangle, _
            br As Brush, _
            Reihe As GewinnReihe, _
            Farbe As ZellenStatus

        If FeldDXY > 0 Then
            If _TerminalOptimierung = TerminalOptimierungen.aus Then
                e.Graphics.FillRectangle(New Drawing2D.LinearGradientBrush(New Point(0, 0), _
                    New Point(Me.Width, Me.Height), Color.Blue, Color.DarkBlue), 0, 0, _
                    Me.Width, Me.Height)
            Else
                e.Graphics.FillRectangle(Brushes.Blue, e.ClipRectangle)
            End If
            e.Graphics.SmoothingMode = Drawing.Drawing2D.SmoothingMode.AntiAlias
            R = New Rectangle(FeldX0, FeldY0, FeldDXY - 2 * Rand, FeldDXY - 2 * Rand)
            For Zeile = 0 To MaxZeile
                R.Y = FeldY0 + (MaxZeile - Zeile) * FeldDXY + Rand
                For Spalte = 0 To MaxSpalte
                    R.X = FeldX0 + Spalte * FeldDXY + Rand
                    If BlinkZaehler Mod 2 = 0 Or Zeile <> BlinkZeile Or Spalte <> BlinkSpalte Then
                        Farbe = Spielfeld(Spalte, Zeile)
                    Else
                        Farbe = ZellenStatus.LeereZelle
                    End If
                    Select Case Farbe
                        Case ZellenStatus.LeereZelle, ZellenStatus.SpielerMarkierungsZelle
                            br = Brushes.White
                        Case ZellenStatus.ComputerZelle
                            If _TerminalOptimierung = TerminalOptimierungen.stark Then
                                br = Brushes.Yellow
                            Else
                                br = New Drawing2D.LinearGradientBrush(New Point(R.X, R.Y), _
                                    New Point(R.X + FeldDXY, R.Y + FeldDXY), _
                                    Color.White, Color.Yellow)
                            End If
                        Case ZellenStatus.SpielerZelle
                            If _TerminalOptimierung = TerminalOptimierungen.stark Then
                                br = Brushes.Red
                            Else
                                br = New Drawing2D.LinearGradientBrush(New Point(R.X, R.Y), _
                                    New Point(R.X + FeldDXY, R.Y + FeldDXY), _
                                    Color.White, Color.Red)
                            End If
                    End Select
                    e.Graphics.FillEllipse(br, R)
                    If Farbe = ZellenStatus.SpielerMarkierungsZelle And Rand > 0 Then
                        e.Graphics.DrawEllipse(New Pen(Color.Red, Rand), R)
                    End If
                Next
            Next
            For Each Reihe In Gewinnreihen
                Reihe.Fill(e.Graphics, FeldDXY, FeldX0, FeldY0, Rand)
            Next
            If _Siegrahmen Then
                For Each Reihe In Gewinnreihen
                    Reihe.Draw(e.Graphics, FeldDXY, FeldX0, FeldY0, Rand)
                Next
            End If
        End If
    End Sub

    Private Sub BlinkTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles BlinkTimer.Tick
        If BlinkZaehler > 0 Then
            BlinkZaehler -= 1
            InvalidateSpalteZeile(BlinkSpalte, BlinkZeile)
        End If
        If BlinkZaehler < 1 Then
            BlinkTimer.Enabled = False
        End If
    End Sub

#End Region

End Class
